{$R-,S-,Q-,G-}
unit PADDfunctions;

{$DEFINE FINAL}

interface

uses
  PADDvars,
  support;

type
  str5=string[5];
  str10=string[10];

procedure Abort(errnum:byte;s:s79);
procedure DOSAbsDiskRead(DriveLetter:char; StartSector:longint;
                         NumSectors:word; buf:pointer; var err:word);
procedure DOSAbsDiskwrite(DriveLetter:char; StartSector:longint;
                          NumSectors:word; buf:pointer; var err:word);
procedure AbortINT2526Error(err:word);
function FATVal(cluster:word):word;
Procedure SetFAT(cluster,value:word);
function FATValFree:word;
function ReadCluster(clusnum:word;buf:pointer):word;
function Showbuffer(buf,dest:pointer;bufsize,viewstart:word;viewmode:viewtype):word;
function FindNextFreeClus(start:word):word;
function FindPrevFreeClus(start:word):word;
procedure PrintCmdLineHelp;
procedure PrintViewerHelp;
function SameVal(buf:pointer;bufsize:word;byteval:byte):boolean;
function numfmt(w:word):str5;
function DOSFNDate(dw:word):str10;
procedure BIOSClrScr;
function Confirm(s:string):boolean;
function firstSectorOfCluster(clus:word):longint;
procedure CacheFATFromDisk;
procedure FlushFATToDisk;

implementation

procedure cmdlinehelptext; external;
{$L paddcmdl.obj}
Procedure PrintCmdLineHelp;assembler;
asm
  mov     bx,SEG cmdlinehelptext
  mov     dx,OFFSET cmdlinehelptext
  push    ds
  mov     ds,bx
  mov     ah,09
  int     21h
  pop     ds
end;

procedure viewerhelptext; external;
{$L paddhelp.obj}
Procedure PrintViewerHelp;assembler;
asm
  mov     bx,SEG viewerhelptext
  mov     dx,OFFSET viewerhelptext
  push    ds
  mov     ds,bx
  mov     ah,09
  int     21h
  pop     ds
end;

function Showbuffer(buf,dest:pointer;bufsize,viewstart:word;viewmode:viewtype):word;
{Displays a buffer in various ways and returns how many were displayed}
const
  firstrow=1;
  numrows=24-firstrow;

begin
  case viewmode of
    rawview:asm
      mov dx,bufsize
      mov bx,viewstart
      les di,dest
      add di,80*2*firstrow              {advance dest to starting row}
      mov cx,80*numrows                 {number of bytes to display}
      {prepare screen}
      push cx
      push di
      mov ax,$0700
      rep stosw
      pop di
      pop cx
      {finish drawing buffer}
      sub dx,bx                         {total=total - viewstart}
      cmp cx,dx                         {total smaller than screen?}
      jb  @go
      mov cx,dx                         {move only total}
    @go:
      mov @result,cx                    {this is what we'll return to user}
      push ds
      lds si,buf
      add si,bx
    @show:
      lodsb
      stosb
      inc di
      loop @show
      pop ds
    end;
    printable:asm
      mov dx,bufsize
      mov bx,viewstart
      les di,dest
      add di,80*2*firstrow              {advance dest to starting row}
      mov cx,80*numrows                 {number of bytes to display}
      {prepare screen}
      push cx
      push di
      mov ax,$0700
      rep stosw
      pop di
      pop cx
      {finish drawing buffer}
      sub dx,bx                         {total=total - viewstart}
      cmp cx,dx                         {total smaller than screen?}
      jb  @go
      mov cx,dx                         {move only total}
    @go:
      mov @result,cx                    {this is what we'll return to user}
      push ds
      lds si,buf
      add si,bx
    @show:
      lodsb
      cmp al,32
      jb @notprintable
      cmp al,127
      ja @notprintable
      stosb
      inc di
    @notprintable:
      loop @show
      pop ds
    end;
    hexview16:asm
      mov dx,bufsize
      mov bx,viewstart
      les di,dest
      add di,80*2*firstrow              {advance dest to starting row}
      mov cx,80*numrows                 {number of bytes to display}
      {prepare screen}
      push cx
      push di
      mov ax,$0700
      rep stosw
      pop di
      pop cx
      {finish drawing buffer}
      mov cx,16*numrows
      sub dx,bx                         {total=total - viewstart}
      cmp cx,dx                         {total smaller than screen?}
      jb  @go
      mov cx,dx                         {if so, display only total}
    @go:
      mov @result,cx                    {this is what we'll return to user}
      push ds
      lds si,buf
      add si,bx
      shr cx,1
      shr cx,1
      shr cx,1
      shr cx,1                          {line loop = number of lines to show}
    @showline:
      {print 16 hex digits}
      push cx
      mov cx,16
      @do16hex:
        lodsb
        mov bl,al
        {convert to printable hex digit}
        shr al,1
        shr al,1
        shr al,1
        shr al,1
        cmp al,10
        sbb al,69h
        das
        stosb
        inc di
        mov al,bl
        and al,$0f
        cmp al,10       {if x<10, set CF=1}
        sbb al,69h      {0-9: 96h..9Fh, A-F: A1h..A6h}
        das             {0-9: subtr. 66h -> 30h-39h; A-F: subtr. 60h -> 41h-46h}
        stosb
        inc di

        inc di          {print a space}
        inc di
        inc di          {print a space}
        inc di
      loop @do16hex
      sub si,16         {print these same 16 again}
      mov cx,16
      @do16raw:
        lodsb
        stosb
        inc di
      loop @do16raw
      pop cx
      loop @showline
      pop ds
    end;
    hexview20:asm
      mov dx,bufsize
      mov bx,viewstart
      les di,dest
      add di,80*2*firstrow              {advance dest to starting row}
      mov cx,80*numrows                 {number of bytes to display}
      {prepare screen}
      push cx
      push di
      mov ax,$0700
      rep stosw
      pop di
      pop cx
      {finish drawing buffer}
      mov cx,20*numrows
      sub dx,bx                         {total=total - viewstart}
      cmp cx,dx                         {total smaller than screen?}
      jb  @go
      mov cx,dx                         {if so, display only total}
    @go:
      mov @result,cx                    {this is what we'll return to user}
      push ds
      lds si,buf
      add si,bx
      xchg cx,ax
      mov bl,20
      div bl                            {div to get num lines to display}
      xor ah,ah
      xchg cx,ax
    @showline:
      {print 20 hex digits}
      push cx
      mov cx,20
      @do20hex:
        lodsb
        mov bl,al
        {convert to printable hex digit}
        shr al,1
        shr al,1
        shr al,1
        shr al,1
        cmp al,10
        sbb al,69h
        das
        stosb
        inc di
        mov al,bl
        and al,$0f
        cmp al,10       {if x<10, set CF=1}
        sbb al,69h      {0-9: 96h..9Fh, A-F: A1h..A6h}
        das             {0-9: subtr. 66h -> 30h-39h; A-F: subtr. 60h -> 41h-46h}
        stosb
        inc di

        inc di          {print a space}
        inc di
      loop @do20hex
      sub si,20         {print these same 20 again}
      mov cx,20
      @do20raw:
        lodsb
        stosb
        inc di
      loop @do20raw
      pop cx
      loop @showline
      pop ds
    end;
    hexview24:asm
      mov dx,bufsize
      mov bx,viewstart
      les di,dest
      add di,80*2*firstrow              {advance dest to starting row}
      mov cx,80*numrows                 {number of bytes to display}
      {prepare screen}
      push cx
      push di
      mov ax,$0700
      rep stosw
      pop di
      pop cx
      {finish drawing buffer}
      mov cx,24*numrows
      sub dx,bx                         {total=total - viewstart}
      cmp cx,dx                         {total smaller than screen?}
      jb  @go
      mov cx,dx                         {if so, display only total}
    @go:
      mov @result,cx                    {this is what we'll return to user}
      push ds
      lds si,buf
      add si,bx
      xchg cx,ax
      mov bl,24
      div bl                            {div to get num lines to display}
      xor ah,ah
      xchg cx,ax
    @showline:
      {print 24 hex digits, no spaces}
      push cx

      {print line number}
      mov  dx,si        {dx=bufferpos}
      mov  cl,4
      mov  bl,4
      @print4:
        rol  dx,cl
        mov  al,dl
        and  al,$0f
        cmp  al,10
        sbb  al,69h
        das
        stosb
        inc  di
        dec  bl
      jnz  @print4
      mov al,'h'
      stosb
      inc di
      mov al,':'
      stosb
      inc di

      inc di
      inc di

      {print the hex digits}
      mov cx,24
      @do24hex:
        lodsb
        mov bl,al
        {convert to printable hex digit}
        shr al,1
        shr al,1
        shr al,1
        shr al,1
        cmp al,10
        sbb al,69h
        das
        stosb
        inc di
        mov al,bl
        and al,$0f
        cmp al,10       {if x<10, set CF=1}
        sbb al,69h      {0-9: 96h..9Fh, A-F: A1h..A6h}
        das             {0-9: subtr. 66h -> 30h-39h; A-F: subtr. 60h -> 41h-46h}
        stosb
        inc di
      loop @do24hex
      sub si,24         {print these same 16 again}
      inc di
      inc di            {move into draw position}
      mov cx,24
      @do24raw:
        lodsb
        stosb
        inc di
      loop @do24raw
      pop cx
      loop @showline
      pop ds
    end;
  end;
end;


procedure Abort(errnum:byte;s:s79);
begin
  writeln(#13#10'Fatal error #',errnum,': ',s);
  halt(errnum);
end;

Procedure DOSAbsDiskRead(DriveLetter:char; StartSector:longint;
                         NumSectors:word; buf:pointer; var err:word);
type
  controlBlock=record
    Sector:longint;
    Num:word;
    destbuf:pointer;
  end;

var
  CB:ControlBlock;
  p:pointer;

begin
  {if we are a FAT16 filesystem}
  if (driveinfo.fat=fat16)
  {or our variables physically exceed the legacy call format}
  or (StartSector>$ffff) or (numSectors>$fffe) then begin
    {fat16 read -- requires control block call method}
    with CB do begin
      Sector:=StartSector;
      Num:=NumSectors;
      destbuf:=buf;
    end;
    p:=@CB;
    asm
      mov     al,DriveLetter
      sub     al,65           {0=a, 1=b, 2=c, etc.}
      mov     cx,-1
      push    bp              {Compaq DOS 3.31 trashes BP}
      push    ds
      lds     bx,p
      int     25h
      jc      @error
      xor     ax,ax
    @error:
      popf                    {restore prior flags (quirk of INT 25)}
      pop     ds
      pop     bp
      les     di,err
      mov     es:[di],ax
    end;
  end else begin
    asm
      mov     al,DriveLetter
      sub     al,65           {0=a, 1=b, 2=c, etc.}
      mov     cx,NumSectors
      mov     dx,WORD PTR StartSector
      push    bp              {Compaq DOS 3.31 trashes BP}
      push    ds
      lds     bx,buf
      int     25h
      jc      @error
      xor     ax,ax
    @error:
      popf                    {restore prior flags (quirk of INT 25)}
      pop     ds
      pop     bp
      les     di,err
      mov     es:[di],ax
    end;
  end;
  {Examination of CPWIN386.CPL indicates that if this call fails with
  error 0408h on an old-style (<32M) call, one should retry the call
  with the high bit of the drive number in AL set.}
  if err=$0408
    then DOSAbsDiskRead(char(byte(DriveLetter) OR $80),StartSector,NumSectors,buf,err);
  if err<>0 then AbortINT2526Error(err);
end;

Procedure DOSAbsDiskWrite(DriveLetter:char; StartSector:longint;
                          NumSectors:word; buf:pointer; var err:word);
type
  controlBlock=record
    Sector:longint;
    Num:word;
    destbuf:pointer;
  end;

var
  CB:ControlBlock;
  p:pointer;

begin
  {if we are a FAT16 filesystem}
  if (driveinfo.fat=fat16)
  {or our variables physically exceed the legacy call format}
  or (StartSector>$ffff) or (numSectors>$fffe) then begin
    {fat16 read -- requires control block call method}
    with CB do begin
      Sector:=StartSector;
      Num:=NumSectors;
      destbuf:=buf;
    end;
    p:=@CB;
    asm
      mov     al,DriveLetter
      sub     al,65           {0=a, 1=b, 2=c, etc.}
      mov     cx,-1
      push    bp              {Compaq DOS 3.31 trashes BP}
      push    ds
      lds     bx,p
      int     26h
      jc      @error
      xor     ax,ax
    @error:
      popf                    {restore prior flags (quirk of INT 25)}
      pop     ds
      pop     bp
      les     di,err
      mov     es:[di],ax
    end;
  end else begin
    asm
      mov     al,DriveLetter
      sub     al,65           {0=a, 1=b, 2=c, etc.}
      mov     cx,NumSectors
      mov     dx,WORD PTR StartSector
      push    bp              {Compaq DOS 3.31 trashes BP}
      push    ds
      lds     bx,buf
      int     26h
      jc      @error
      xor     ax,ax
    @error:
      popf                    {restore prior flags (quirk of INT 25)}
      pop     ds
      pop     bp
      les     di,err
      mov     es:[di],ax
    end;
  end;
  {Examination of CPWIN386.CPL indicates that if this call fails with
  error 0408h on an old-style (<32M) call, one should retry the call
  with the high bit of the drive number in AL set.}
  if err=$0408
    then DOSAbsDiskRead(char(byte(DriveLetter) OR $80),StartSector,NumSectors,buf,err);
  if err<>0 then AbortINT2526Error(err);
end;

procedure AbortINT2526Error(err:word);
begin
  BIOSClrScr;
  write(#13#10'Error accessing the disk!'#13#10' DOS reports: ');
  case hi(err) of
    $01:writeln('bad command');
    $02:writeln('bad address mark');
    $03:writeln('write protect');
    $04:writeln('sector not found');
    $08:writeln('DMA failure');
    $10:writeln('data error (bad CRC)');
    $20:writeln('controller failed');
    $40:writeln('seek failed');
    $80:writeln('attachment failed to respond');
  else
    writeln('Unknown error');
  end; {case}

  write('BIOS reports: ');
  case lo(err) of
    $00:writeln('write protect error');
    $01:writeln('unknown unit');
    $02:writeln('drive not ready');
    $03:writeln('unknown command');
    $04:writeln('data error (bad CRC)');
    $05:writeln('bad request structure length');
    $06:writeln('seek error');
    $07:writeln('unknown media type');
    $08:writeln('sector not found');
    $0A:writeln('write fault');
    $0B:writeln('read fault');
    $0C:writeln('general failure');
  else
    writeln('Unknown error');
  end; {case}

  abort(5,'Cannot continue after INT 25h/26h error (AX): '+hexword(err));
end;

(* 433 microseconds FAT12, 528 microseconds FAT16
function FATVal(cluster:word):word;
{returns the FAT value at cluster N using the in-memory FAT copy}
var
  wp:^word;
  l:longint;
  Fval:word;
begin
  with DriveInfo do begin
    wp:=FATCopy;
    if fat=fat16 then begin
      l:=cluster; l:=l*2; {this is because wordval*2 throws overflow when w=$8000.  I hate TP bugs!}
      wp:=addptr(wp,l);
      FVal:=wp^;
    end else begin
      {FAT12 reads are a little more complicated}
      {entries are 1.5 bytes long -- mul by 3 then div 2}
      wp:=addptr(wp,(cluster*3) div 2);
      FVal:=wp^;
      {if num is even, keep low 12 bits; if odd, keep upper 12 bits}
      if (cluster AND 1)=0
        then FVal:=FVal AND $0fff
        else FVal:=FVal SHR 4;
    end;
  end;
  FATVal:=FVal;
end;*)

{New speed: FAT16:98, FAT12:105}
function FATVal(cluster:word):word; assembler;
{
Returns the FAT value at cluster N using the in-memory FAT copy.
This branchles gem made possible with help from Terje Mathisen - thanks!
}
asm
  cmp DriveInfo.FAT,FAT16
  jne @FAT12Read

@FAT16Read:
  mov di,[cluster]
  xor bx,bx
  shl di,1                    {carry+DI=cluster# * 2}
  adc bx,0                    {carry bit now in BX}
  {At this point DI is word-aligned, and BX has the top bit}
  shl bx,1                    {BX=0 if address in first 64K, BX=2 for second}
  mov es,WORD PTR FATSegs[bx] {ES=first or second segment, table lookup}
  mov ax,es:[di]              {grab cluster's value}
  jmp @done

@FAT12Read:
  mov bx,[cluster]            {grab cluster#}
  mov cx,bx                   {grab for calcs and odd/even}
  shl bx,1                    {bx=cluster# * 2}
  add bx,cx                   {bx=cluster# * 3}
  shr bx,1                    {bx=cluster# * 1.5}

  and cl,1                    {odd or even?}
  shl cl,1
  shl cl,1                    {cl = 0 if bx was even, 4 if odd}

  mov es,WORD PTR FATSegs     {ES=first segment, table lookup}
  mov ax,es:[bx]              {Get target}
  shr ax,cl                   {Shift by 0 or 4}
  and ax,0fffh                {Keep bottom 12 bits}
@done:
  {value returned in AX}
end;

procedure SetFAT(cluster,value:word); assembler;
{Sets VALUE at cluster CLUSTER in the in-memory FAT copy.}
{if odd, we set UPPER 12 bits; if even, we set LOWER 12 bits}
asm
  cmp DriveInfo.FAT,FAT16
  jne @FAT12Write

@FAT16Write:
  mov di,[cluster]
  xor bx,bx
  shl di,1                    {carry+DI=cluster# * 2}
  adc bx,0                    {carry bit now in BX}
  {At this point DI is word-aligned, and BX has the top bit}
  shl bx,1                    {BX=0 if address in first 64K, BX=2 for second}
  mov es,WORD PTR FATSegs[bx] {ES=first or second segment, table lookup}
  mov ax,value
  mov es:[di],ax              {set cluster's value}
  jmp @done

@FAT12Write:
  mov bx,[cluster]            {grab cluster#}
  mov cx,bx                   {grab for calcs and odd/even}
  shl bx,1                    {bx=cluster# * 2}
  add bx,cx                   {bx=cluster# * 3}
  shr bx,1                    {bx=cluster# * 1.5}

  and cl,1                    {odd or even?}
  shl cl,1
  shl cl,1                    {cl = 0 if bx was even, 4 if odd}

  mov es,WORD PTR FATSegs     {ES=first segment, table lookup}
  mov ax,es:[bx]              {read existing value word}
  mov dx,0fffh                {create mask to save existing contents}
  shl dx,cl                   {adjust mask based on odd or even}
  not dx                      {invert mask}
  shl value,cl                {adjust value based on odd or even}
  and ax,dx                   {keep residual word data}
  or  ax,value                {insert our value}
  mov es:[bx],ax              {store back into cache}
@done:
end;

function FATValFree:word; assembler;
{
Returns the number of free clusters in the FAT copy.  Not optimal,
but much better than calling FATVal $ffff times.
}
asm
  push bp
  xor bp,bp
  mov dx,DriveInfo.NC
  inc dx
  cmp DriveInfo.FAT,FAT16
  jne @FAT12Read

@FAT16Read:
  mov di,dx
  xor bx,bx
  shl di,1                    {carry+DI=cluster# * 2}
  adc bx,0                    {carry bit now in BX}
  {At this point DI is word-aligned, and BX has the top bit}
  shl bx,1                    {BX=0 if address in first 64K, BX=2 for second}
  mov es,WORD PTR FATSegs[bx] {ES=first or second segment, table lookup}
  mov ax,es:[di]              {grab cluster's value}
  or  ax,ax
  jnz @notzero
  inc bp
@notzero:
  dec dx
  cmp dx,1
  je  @done
  jmp @FAT16Read

@FAT12Read:
  mov bx,dx                   {grab cluster#}
  mov cx,bx                   {grab for calcs and odd/even}
  shl bx,1                    {bx=cluster# * 2}
  add bx,cx                   {bx=cluster# * 3}
  shr bx,1                    {bx=cluster# * 1.5}

  and cl,1                    {odd or even?}
  shl cl,1
  shl cl,1                    {cl = 0 if bx was even, 4 if odd}

  mov es,WORD PTR FATSegs     {ES=first segment, table lookup}
  mov ax,es:[bx]              {Get target}
  shr ax,cl                   {Shift by 0 or 4}
  and ax,0fffh                {Keep bottom 12 bits}
  or  ax,ax
  jnz @notzero12
  inc bp
@notzero12:
  dec dx
  cmp dx,1
  je  @done
  jmp @FAT12Read

@done:
  mov ax,bp
  pop bp
  {value returned in AX}
end;

Function ReadCluster(clusnum:word;buf:pointer):word;
{Reads cluster CLUSNUM into buffer BUF and returns any read errors}
{starting sector = DataStart + ((AnyClusterNumber-2) * sectorsPerCluster)}
var
  s:string;
  l:longint;
begin
  with DriveInfo do begin
    l:=firstSectorOfCluster(clusnum);
    {$IFDEF DEBUG}
    s:='CLUSStartSec+((clusnum-2)*SPC) is ';
    s:=s+inttostr(CLUSStartSec)+' ';
    s:=s+inttostr(clusnum-2)+' ';
    s:=s+inttostr(SPC)+' ';
    s:=s+'with value ';
    s:=s+inttostr(l);
    tfastwritexy(@s,vidp,0,3,$70);
    {$ENDIF}

    DOSAbsDiskRead(Letter,l,SPC,buf,gIOerr);
  end;
  ReadCluster:=gIOerr;
end;

function FindNextFreeClus(start:word):word;
const
  notfound=$0000;
var
  wt:word;
begin
  {if we are at range limit, abort}
  if start>DriveInfo.NC+1 then begin
    FindNextFreeClus:=notfound;
    exit;
  end;
  for wt:=start to DriveInfo.NC+1 do
    if FATVal(wt)=$0000 then begin
      FindNextFreeClus:=wt;
      exit;
  end;
  FindNextFreeClus:=notfound;
end;

function FindPrevFreeClus(start:word):word;
const
  notfound=$0000;
var
  wt:word;
begin
  {if we are at range limit, abort}
  if start<2 then begin
    FindPrevFreeClus:=notfound;
    exit;
  end;
  for wt:=start downto 2 do
    if FATVal(wt)=$0000 then begin
      FindPrevFreeClus:=wt;
      exit;
    end;
  FindPrevFreeClus:=notfound;
end;

function SameVal(buf:pointer;bufsize:word;byteval:byte):boolean;assembler;
{returns true (1) if the buffers consists of only byteval, false if not}
asm
  mov     cx,bufsize
  mov     al,byteval
  les     di,buf
  cld
  cmp     aggressiveFsearch,1 {is aggressiveFsearch true?}
  jne     @searchit   {if not, start the search}
  mov     al,es:[di]  {otherwise, load the very first byte to use as comparision val}
@searchit:
  repz    scasb       {cx=0 if all same val}
  cmp     cx,1        {copy ZF to CF}
  lahf                {copy flags to AH}
  and     ah,1        {isolate CF (ZF)}
  mov     al,ah       {al = 1 = true if cx=0}
end;

function numfmt(w:word):str5;
var
  ww:word;
begin
  if numhex
    then numfmt:=hexword(w)+'h'
    else numfmt:=intpadded(w,5,'0');
end;

function DOSFNDate(dw:word):str10;
{Takes a DOS date word and turns it into a yyyy-mm-dd string}
var
  y,m,d:word;
  s:str10;
begin
  asm
    mov ax,dw
    mov bx,ax
    and bx,0000000000011111b
    mov d,bx

    mov bx,ax
    and bx,0000000111100000b
    mov cl,5
    shr bx,cl
    mov m,bx

    mov bx,ax
    {and bx,1111111000000000b}
    mov cl,9
    shr bx,cl
    add bx,1980
    mov y,bx
  end;
  if d<10 then s:='-0'+inttostr(d)   else s:='-'+inttostr(d);
  if m<10 then s:='-0'+inttostr(m)+s else s:='-'+inttostr(m)+s;
  s:=inttostr(y)+s;
  DOSFNDate:=s;
end;

procedure BIOSClrScr;assembler;
{                      INT 10,6 - Scroll Window Up
        AH = 06
        AL = number of lines to scroll, previous lines are
             blanked, if 0 or AL > screen size, window is blanked
        BH = attribute to be used on blank line
        CH = row of upper left corner of scroll window
        CL = column of upper left corner of scroll window
        DH = row of lower right corner of scroll window
        DL = column of lower right corner of scroll window}
asm
  mov ax,0600h
  mov bh,07
  xor cx,cx
  mov dx,184fh {mov dh,24; mov dl,79}
  int 10h
  {re-home cursor}
  mov ah,2
  xor bh,bh {page 0}
  xor dx,dx
  int 10h
end;

function Confirm(s:string):boolean;
var
  c:char;
begin
  if not skipprompts then begin
    write(#13#10,s,' (Y/N) ');
    c:=readkeychar; writeln;
    Confirm:=(upcase(c)='Y');
  end else Confirm:=true;
end;

function firstSectorOfCluster(clus:word):longint;
begin
  {need to cast this to longint or else TP throws a fit}
  firstSectorOfCluster:=longint(DriveInfo.CLUSStartSec) + ((longint(clus)-2) * longint(DriveInfo.SPC));
end;

procedure CacheFATFromDisk;
var
  i:integer;
  p:pointer;
  l:longint;
begin
  with DriveInfo do begin
    i:=FATNumSectors;
    p:=FATCopy;
    l:=FATStartSec;
    repeat
      {read chunks of FAT into memory segments}
      if i<secsPerSeg
        then DOSAbsDiskRead(Letter,l,i,p,gIOerr)
        else DOSAbsDiskRead(Letter,l,secsPerSeg,p,gIOerr);
      p:=addptr(p,segsize);   {advance memory pointer to next segment}
      i:=i-secsPerSeg; {subtract num of sectors to read}
      l:=l+secsPerSeg; {advance to next sector load position}
    until i<=0;
  end;
end;

procedure FlushFATToDisk;
var
  i:integer;
  p:pointer;
  l:longint;
begin
  with DriveInfo do begin
    i:=FATNumSectors;
    p:=FATCopy;
    l:=FATStartSec;
    repeat
      {read chunks of FAT into memory segments}
      if i<secsPerSeg
        then DOSAbsDiskWrite(Letter,l,i,p,gIOerr)
        else DOSAbsDiskWrite(Letter,l,secsPerSeg,p,gIOerr);
      p:=addptr(p,segsize);   {advance memory pointer to next segment}
      i:=i-secsPerSeg; {subtract num of sectors to read}
      l:=l+secsPerSeg; {advance to next sector load position}
    until i<=0;
  end;
end;

end.